package com.javaseleniumtemplate.pages;
import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;

public class AjusteInventarioPage extends PageBase {

    //Evento de loading da pagina:
        By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");
    //BUSCA DO PRODUTO ATRAVES DO FLOAT-CONTROL:

        By campoProcurarFloatControl = By.xpath("//*[@id='popup']//*[@placeholder='Procurar']");

    //Aplicando os paramentros no Filtro inicial:
        By clearFilter = By.xpath("//*[@data-zh-id='2085279469498787152459_filter_action_clear']");
        By IconeUnidade = By.xpath("//*[@data-zh-id='208527946922898167425048']//*[@id='NMFILIAL']/span[1]");
        By SelecioanarUnidadeAjusteIventario = By.xpath("//*[@data-zh-field-name='NMFILIAL']//*[.='HELA INGREDIENTES BRASIL']");
        By IconeData = By.xpath("//*[@data-zh-id='208527946925069924912507']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
        By DataEscolhidaInicial = By.xpath("//*[@id='zh-calendar-Calendar']//*[.='1']");
        By BtnOkFiltro = By.xpath("//*[@id='footer']/div[3]/ul/li/a/span");
        By IconeOperador = By.xpath("//*[@data-zh-id='208527946916820554232513']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By codOperador = By.xpath("//*[@id='grid-9000']//*[.='000000218419']");
        By aplicarFiltro = By.xpath("//*[@data-zh-id='2085279469498787152459_filter_action_never']//span[text() = 'Aplicar filtro']"); //data-zh-id esta vazio

    //Adicionando Ajuste de inventario:
        By btnAdicionar = By.xpath("//*[@id='footer']//*[@data-zh-id='208527946931600053562520']");
        By btnAdicionar2 = By.xpath("//*[@data-zh-id='20852794697104433322483']");
        By caixaTextoAjusteIventario = By.xpath("//*[@class='zh-text-alert']");//Nao precisa de data-zh-id
        By btnOkAlert = By.xpath("//*[@class='zh-container-alert']//*[@data-zh-id='zh-footer-alert-button-0']");
        By btnXlimpar = By.xpath("//*[@data-zh-id='208527946925069924912507']//*[@zh-icon='no-border close-x']");
        By btnCalendario = By.xpath("//*[@data-zh-id='208527946925069924912507']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
        By DataEscolhida = By.xpath("//div[@class='day today']");//Nao precisa de data-zh-id
        By campoDescricao = By.xpath("//*[@zh-id='208527946936254289722511']");
        By btnSalvar = By.xpath("//*[@data-zh-id='208527946937190993162526']");
        By btnIcon = By.xpath("//*[@data-zh-id='208527946917703242502463']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By produto = By.xpath("//*[@id='grid-9000']//*[.='Hela Poultry Broth Paste Clear KG']");//Nao precisa de data-zh-id
        By btnXlimpar2 = By.xpath("//*[@data-zh-id='764527517256954914288']//*[@id='DSALMOXARIFE']/span[2]");
        By btnIconAlmoxarifado = By.xpath("//*[@data-zh-id='764527517256954914288']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By almoxarifado = By.xpath("//*[@id='grid-9000']//*[.='HELA MATRIZ']");//Nao precisa de data-zh-id
        By confirmar = By.xpath("//*[@data-zh-id='7645275174220205724322']//*[.='Confirmar']");
        By btnIconLote = By.xpath("//*[@data-zh-id='7645275171631791325304']");

        By selectLote = By.xpath("//*[@data-zh-id='7645275172186633453300']//*[@tabindex='0']");
        By loteExistente = By.xpath("//ul[@class='list zh-new-select-list']/li[1]");

        By btnLupaLote = By. xpath("//*[@id='NRLOTEESTQ']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By lote = By.xpath("//span[text()='00231100']");//Nao precisa de data-zh-id
        By quantidadeProduto = By.xpath("//*[@zh-id='208527946938333229262469']");
        By btnSalvar2 = By.xpath("//*[@data-zh-id='208527946940788756772491']");


        By btnConfirmarEstoque = By.cssSelector("div > #footer > .zh-footer-right .zh-footer-title-sprit");
        By btnAtualizarEstoque = By.xpath("//span[text()='Atualizar Estoque']");

        By btnGravar = By.xpath("//*[@data-zh-id='zh-footer-alert-button-0']");
        By caixaTextoEstoqueAtualizadoComSucesso = By.xpath("//*[@class='zh-container-alert']");//Nao precisa de data-zh-id
        By BtnOk = By.xpath("//*[@data-zh-id='zh-footer-alert-button-0']");

    //EDITAR AJUSTE IVENTARIO:
        By localizandoDescricao = By.xpath("//span[text()='Teste Automatizado']");
        By btnEditar = By.xpath("//*[@id='footer']//*[@data-zh-id ='208527946928758746902516']");
        By btnSim = By.xpath("//*[@class='zh-container-alert']//*[@data-zh-id='zh-footer-alert-button-0']");
        By campoDescricao2 = By.xpath("//*[@zh-id='208527946936254289722511']");
        By abaProduto = By.xpath("//*[@data-zh-id='masterDetailTabbedWidget']//li[2]/label");
        By btnAdicionar3 = By.xpath("//*[@data-zh-id='20852794697104433322483']");
        By btnIconSearch = By.xpath("//*[@data-zh-id='208527946917703242502463']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By produto2 = By.xpath("//*[@id='grid-9000']//*[.='Ochsenbuillon Paste (Hela 7565810050001)']");
        By lote2 = By.xpath("//span[text()='20013001']");//Nao precisa de data-zh-id

        By btnValidade = By.xpath("//*[@data-zh-id='76452751786488369316']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
        By dataValidade = By.xpath("//div[@class='day today']");


        By clickCampoQuantidade = By.id("QTTOTLANCTO");
        By btnAtualizarEstoqueEditado = By.xpath("//span[text()='Atualizar Estoque']");
        By btnSalvarAlteracoes = By.xpath("//span[text()='Salvar alterações']");
        By btnEstoqueAtualizadoComSucesso = By.xpath("//*[@data-zh-id='zh-footer-alert-button-0']");
        By btnVoltar = By.xpath("//span[text()'Voltar']");

    //EXCLUIR AJUSTE INVENTARIO:
        By localizandoDescricaoExcluir = By.xpath("//span[text()='Deletar']");
        By btnExcluir = By.xpath("//*[@id='footer']//*[@data-zh-id ='208527946938725575942522']");
        By AlertExcluirRegistro = By.xpath("//*[@class='zh-container-alert']//*[@class='zh-container-text-alert']");

    //Importar Ajuste de inventario:
       By btnImportar = By.xpath("//*[@id='footer']//*[@data-zh-id='20852794691123972999134']");
       By btnEscolherArquivo = By.xpath("//*[@data-zh-id='20852794693995615714784']//*[@id='UPLOADFILE_button']");

    //Banco

    By numerolancado = By.cssSelector("#span-field-NRLANCESTQ > .zh-field-value");
    By voltar = By.xpath("//span[text()='Voltar']");


    public void preencherFiltroAjusteIventario(String descUnidade,String descOperador){

        //FILTRO INICIAL:
        click(clearFilter);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(IconeUnidade);
        click(IconeUnidade);

        //inicio busca no float-control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
        //fim busca no float-control

        waitForVisibilityOfElementLocated(SelecioanarUnidadeAjusteIventario);
        click(SelecioanarUnidadeAjusteIventario);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(IconeData);
        click(IconeData);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(DataEscolhidaInicial);
        click(DataEscolhidaInicial); //Data final aparece automaticamente.
        waitForVisibilityOfElementLocated(BtnOkFiltro);
        click(BtnOkFiltro); //data-zh-id esta vazio
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(IconeOperador);
        click(IconeOperador);
        //inicio busca no float-control

        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descOperador);
        waitForInvisibilityOfElementLocated(loadingWait);
        //fim busca no float-control

        waitForVisibilityOfElementLocated(codOperador);
        click(codOperador);
        waitForVisibilityOfElementLocated(aplicarFiltro);
        click(aplicarFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);

    }
    public void AdicionarAjusteIventario(String quantidade, String cmpDesc,String descProduto,String descAlmoxarifado,String descLote){
        //INICIO:
        waitForVisibilityOfElementLocated(btnAdicionar);
        click(btnAdicionar);
        //SUB-ABA AJUSTE DE INVENTARIO:
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(caixaTextoAjusteIventario);
        waitForVisibilityOfElementLocated(btnOkAlert);
        click(btnOkAlert);
        waitForVisibilityOfElementLocated(btnXlimpar);
        click(btnXlimpar);
        waitForVisibilityOfElementLocated(btnCalendario);
        click(btnCalendario);
        waitForVisibilityOfElementLocated(DataEscolhida);
        click(DataEscolhida);
        waitForVisibilityOfElementLocated(campoDescricao);
        click(campoDescricao);
        sendKeys(campoDescricao,cmpDesc);
        waitForVisibilityOfElementLocated(btnSalvar);
        click(btnSalvar);
        waitForInvisibilityOfElementLocated(loadingWait);

        //ABA PRODUTOS:
        waitForVisibilityOfElementLocated(btnAdicionar2);
        click(btnAdicionar2);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnIcon);
        click(btnIcon);
        waitForInvisibilityOfElementLocated(loadingWait);

        //inicio busca no float-control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
        //fim  busca no float-control

        waitForVisibilityOfElementLocated(produto);
        click(produto); //o nome do prod esta na busca do xpath tbm(nao precisa de zh-id).
        waitForInvisibilityOfElementLocated(loadingWait);

        //SUB FILTRO - INFORMAÇOES COMPLEMENTARES DO PRODUTO:
        waitForVisibilityOfElementLocated(btnXlimpar2);
        click(btnXlimpar2);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnIconAlmoxarifado);
        click(btnIconAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);

        //inicio busca no float-control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(almoxarifado);
        click(almoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Lote
        waitForVisibilityOfElementLocated(selectLote);
        click(selectLote);
        waitForVisibilityOfElementLocated(loteExistente);
        click(loteExistente);

        waitForVisibilityOfElementLocated(btnLupaLote);
        click(btnLupaLote);
        waitForInvisibilityOfElementLocated(loadingWait);
        // incio do float
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descLote);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(lote);
        //Fim do float

        waitForVisibilityOfElementLocated(confirmar);
        click(confirmar);
        waitForInvisibilityOfElementLocated(loadingWait);
        //Fim da Busca float-control

        //ABA PRODUTOS:
        waitForVisibilityOfElementLocated(quantidadeProduto);
        click(quantidadeProduto);
        sendKeys(quantidadeProduto,quantidade);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnSalvar2);
        click(btnSalvar2);

        //CAIXA DE ALERTA-02
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnConfirmarEstoque);
        click(btnConfirmarEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(btnAtualizarEstoque);
        click(btnAtualizarEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);

        //CAIXA DE ALERTA-03:
        waitForVisibilityOfElementLocated(caixaTextoAjusteIventario);
        waitForVisibilityOfElementLocated(btnGravar);
        click(btnGravar);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(caixaTextoEstoqueAtualizadoComSucesso);
        waitForVisibilityOfElementLocated(BtnOk);
        click(BtnOk);

        //Banco Captura
        waitForVisibilityOfElementLocated(localizandoDescricao);
        click(localizandoDescricao);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(numerolancado);
        click(numerolancado);

        //waitForVisibilityOfElementLocated(voltar);
        //click(voltar);

    }
    public String retornaNumeroLacamento(){
        return  getText(numerolancado);
    }
    public void EditarAjusteIventario(String cmpDesc2, String quantidade2,String descProduto2,String descAlmoxarifado,String descLote2){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(localizandoDescricao);
        click(localizandoDescricao);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnEditar);
        click(btnEditar);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(campoDescricao2);
        click(campoDescricao2);
        clear(campoDescricao2);
        sendKeys(campoDescricao2,cmpDesc2);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnSalvar);
        click(btnSalvar);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(abaProduto);
        click(abaProduto);
        waitForInvisibilityOfElementLocated(loadingWait);

        //ADICIONANDO O SEGUNDO PRODUTO
        waitForVisibilityOfElementLocated(btnAdicionar3);
        click(btnAdicionar3);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnIconSearch);
        click(btnIconSearch);

        //inicio busca no float-control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descProduto2);
        waitForInvisibilityOfElementLocated(loadingWait);

        //fim  busca no float-control
        waitForVisibilityOfElementLocated(produto2);
        click(produto2);

        //SUB FILTRO - INFORMAÇOES COMPLEMENTARES DO PRODUTO:
        waitForVisibilityOfElementLocated(btnXlimpar2);
        click(btnXlimpar2);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnIconAlmoxarifado);
        click(btnIconAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);

        //inicio busca no float-control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl, descAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(almoxarifado);
        click(almoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);


        waitForVisibilityOfElementLocated(selectLote);
        click(selectLote);
        waitForVisibilityOfElementLocated(loteExistente);
        click(loteExistente);
        waitForVisibilityOfElementLocated(btnLupaLote);
        click(btnLupaLote);
        waitForInvisibilityOfElementLocated(loadingWait);

        // incio do float
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl, descLote2);
        click(lote2);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(confirmar);
        click(confirmar);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Quantidade:
        waitForVisibilityOfElementLocated(quantidadeProduto);
        click(quantidadeProduto);
        sendKeys(quantidadeProduto, quantidade2);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnSalvar2);
        click(btnSalvar2);
        waitForInvisibilityOfElementLocated(loadingWait);

        //EDITANDO QUANTIDADE DO PRIMERO PRODUTO:
        waitForVisibilityOfElementLocated(clickCampoQuantidade);
       //click(clickCampoQuantidade);
       sendKeys(clickCampoQuantidade,quantidade2);
       waitForInvisibilityOfElementLocated(loadingWait);


        //SALVANDO AS ALTERAÇÕES:

       //teste
        //CAIXA DE ALERTA-02
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnConfirmarEstoque);
        click(btnConfirmarEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(btnAtualizarEstoque);
        click(btnAtualizarEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);

        //CAIXA DE ALERTA-03:
        waitForVisibilityOfElementLocated(caixaTextoAjusteIventario);
        waitForVisibilityOfElementLocated(btnGravar);
        click(btnGravar);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(caixaTextoEstoqueAtualizadoComSucesso);
        waitForVisibilityOfElementLocated(BtnOk);
        click(BtnOk);
    }
    public void ExcluirAjusteIventario(){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(localizandoDescricaoExcluir);
        click(localizandoDescricaoExcluir);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnExcluir);
        click(btnExcluir);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(AlertExcluirRegistro);
        waitForVisibilityOfElementLocated(btnSim);
        click(btnSim);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(AlertExcluirRegistro);
        waitForVisibilityOfElementLocated(btnOkAlert);
        click(btnOkAlert);

    }
    public void ImportarAjusteIventario(){
        //INICIO:
        waitForVisibilityOfElementLocated(btnImportar);
        click(btnImportar);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnEscolherArquivo);
        click(btnEscolherArquivo);

    }

}
