package com.javaseleniumtemplate.pages;
import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class ImplantacaoEstoquePage extends PageBase {

    //Evento de loading da pagina:
    By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");
    //BUSCA DO PRODUTO ATRAVES DO FLOAT-CONTROL:
    By iconFloatLupa = By.xpath("//*[@data-zh-id='zh-floating-control-handle']");
    By iconReflesh = By.xpath("//*[@data-zh-id='80926234420126807612533']//*[@data-zh-icon='refresh no-border icon-white']");
    By campoProcurarFloatControl = By.xpath("//*[@id='popup']//*[@placeholder='Procurar']");

    //Aplicando os paramentros no Filtro inicial:
    By clearFilter = By.xpath("//*[@data-zh-id='80926234420126807612533_filter_action_clear']");
    By IconeUnidade = By.xpath("//*[@data-zh-id='80926234421885172782578']//*[@id='NMFILIAL']/span[1]");
    By SelecioanarUnidadeAjusteIventario = By.xpath("//*[@data-zh-field-name='NMFILIAL']//*[.='HELA INGREDIENTES BRASIL']");
    By btnIconAlmoxarifado1 = By.xpath("//*[@data-zh-id='809262344885465619569']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By almoxarifado = By.xpath("//*[@id='grid-9000']//*[.='HELA MATRIZ']");//Nao precisa de data-zh-id
    By IconeData = By.xpath("//*[@data-zh-id='8092623446614594622581']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
    By DataEscolhidaInicial = By.xpath("//*[@id='zh-calendar-Calendar']//*[.='1']");
    By BtnOkFiltro = By.xpath("//*[@id='footer']/div[3]/ul/li/a/span");
    By aplicarFiltro = By.xpath("//*[@data-zh-id='80926234420126807612533_filter_action_never']//span[text() = 'Aplicar filtro']"); //data-zh-id esta vazio

    //Adicionando Implantação de Estoque:
    By btnAdicionar = By.xpath("//*[@id='footer']//*[@data-zh-id='80926234410535704702594']");
    By caixaTextoImplantacaoEstoque = By.xpath("//*[@class='zh-text-alert']");//Nao precisa de data-zh-id
    By btnOkAlert = By.xpath("//*[@class='zh-container-alert']//*[@data-zh-id='zh-footer-alert-button-0']");
    By btnXlimpar = By.xpath("//*[@data-zh-id='8092623446614594622581']//*[@zh-icon='no-border close-x']");
    By btnCalendario = By.xpath("//*[@data-zh-id='8092623446614594622581']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
    By DataEscolhida = By.xpath("//div[@class='day today']");//Nao precisa de data-zh-id
    By campoDescricao = By.xpath("//*[@zh-id='8092623443657433292585']");
    By btnSalvar = By.xpath("//*[@data-zh-id='80926234433852591892600']");
    By btnAdicionar2 = By.xpath("//*[@data-zh-id='8092623444596369402557']");
    By btnIcon = By.xpath("//*[@data-zh-id='80926234414180630162537']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By produto = By.xpath("//*[@id='grid-9000']//*[.='Hela Poultry Broth Paste Clear KG']");//Nao precisa de data-zh-id
    By btnXlimpar2 = By.xpath("//*[@data-zh-id='764527517256954914288']//*[@id='DSALMOXARIFE']/span[2]");
    By btnIconAlmoxarifado2 = By.xpath("//*[@data-zh-id='764527517256954914288']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By campoLote = By.xpath("//*[@data-zh-id='7645275171631791325304']//input");

    By btnCalendario2 = By.xpath("//*[@data-zh-id='76452751786488369316']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
    By DataEscolhidaAtual = By.xpath("//*[@class='day today']");//Nao precisa de data-zh-id
    By confirmar = By.xpath("//*[@data-zh-id='7645275174220205724322']//*[.='Confirmar']");
    By btnSim = By.xpath("//*[@class='zh-container-alert']//*[@data-zh-id='zh-footer-alert-button-0']");
    By campoQuantidade = By.xpath("//*[@zh-id='80926234441521558402543']");
    By campoVrLiquido = By.xpath("//*[@zh-id='80926234430890756602547']");
    By campoVrBruto = By.xpath("//*[@zh-id='8092623446193716132550']");
    By btnSalvar3 = By.xpath("//*[@data-zh-id='80926234426110987472563']");
    By btnAtualizarEstoque = By.xpath("//*[@data-zh-id='80926234410370767582565']");
    By caixaTextoEstoqueAtualizadoComSucesso = By.xpath("//*[@class='zh-container-alert']");//Nao precisa de data-zh-id
    By btnEstoqueAtualizadoComSucesso = By.xpath("//*[@data-zh-id='zh-footer-alert-button-0']");
    By btnGravar = By.xpath("//*[@data-zh-id='zh-footer-alert-button-0']");

    //EDITAR AJUSTE IVENTARIO:
    By localizandoDescricao = By.xpath("//span[text()='Teste Automatizado']");
    By btnEditar = By.xpath("//*[@id='footer']//*[@data-zh-id ='80926234441741111122590']");
    By campoDescricao2 = By.xpath("//*[@zh-id='8092623443657433292585']");
    By abaProduto = By.xpath("//*[@data-zh-id='masterDetailTabbedWidget']//li[2]/label");
    By btnAdicionar3 = By.xpath("//*[@data-zh-id='8092623444596369402557']");
    By btnIconSearch = By.xpath("//*[@data-zh-id='80926234414180630162537']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By produto2 = By.xpath("//*[@id='grid-9000']//*[.='Geflugelbruhe Paste (Hela 7562510050001)']");


    //EXCLUIR IMPLANTACAO DE ESTOQUE:
    By localizandoDescricaoExcluir = By.xpath("//*[.='Deletar']");
    By btnExcluir = By.xpath("//*[@id='footer']//*[@data-zh-id ='8092623449366967722596']");
    By AlertExcluirRegistro = By.xpath("//*[@class='zh-container-alert']//*[@class='zh-container-text-alert']");

    //Importar Ajuste de inventario:
    By btnImportar = By.xpath("//*[@id='footer']//*[@data-zh-id='8092623441835702972577']");
    By btnEscolherArquivo = By.xpath("//*[@data-zh-id='8092623442400064326911']//*[@id='UPLOADFILE_button']");

    //FILTRO INICIAL:
    public void limparFiltro() {
        waitForVisibilityOfElementLocated(clearFilter);
        click(clearFilter);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void selecionarUnidade() {
        waitForVisibilityOfElementLocated(IconeUnidade);
        click(IconeUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void campoBusca() {
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
    }

    public void digitarNomeDaUnidade(String descUnidade) {
        sendKeys(campoProcurarFloatControl, descUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //selecionarUnidade
    public void clicarNaUnidadePesquisada() {
        waitForVisibilityOfElementLocated(SelecioanarUnidadeAjusteIventario);
        click(SelecioanarUnidadeAjusteIventario);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //ALMOXARIFADO:
    public void clicarNoIconeAlmoxarifado() {
        waitForVisibilityOfElementLocated(btnIconAlmoxarifado1);
        click(btnIconAlmoxarifado1);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void digitarAlmoxarifado(String descAlmoxarifado) {
        sendKeys(campoProcurarFloatControl, descAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void clicarNoAlmoxarifadoPesquisado() {
        waitForVisibilityOfElementLocated(almoxarifado);
        click(almoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //Data
    public void clicarIconeData() {
        waitForVisibilityOfElementLocated(IconeData);
        click(IconeData);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void selecionarDataInicialDoFiltro() {
        waitForVisibilityOfElementLocated(DataEscolhidaInicial);
        click(DataEscolhidaInicial); //Data final aparece automaticamente.
    }

    public void confirmarData() {
        waitForVisibilityOfElementLocated(BtnOkFiltro);
        click(BtnOkFiltro); //data-zh-id esta vazio
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void aplicarFiltro() {
        waitForVisibilityOfElementLocated(aplicarFiltro);
        click(aplicarFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //INICIO:
    public void clicarEmAdicionar() {
        waitForVisibilityOfElementLocated(btnAdicionar);
        click(btnAdicionar);
    }

    public void clicarCaixaTextoImplantacao() {
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(caixaTextoImplantacaoEstoque);
        waitForVisibilityOfElementLocated(btnOkAlert);
        click(btnOkAlert);
    }

    public void clicarEmLimpar() {
        waitForVisibilityOfElementLocated(btnXlimpar);
        click(btnXlimpar);
    }

    public void botaoCalendario() {
        waitForVisibilityOfElementLocated(btnCalendario);
        click(btnCalendario);
    }

    public void campoDescricao(String cmpDesc) {
        waitForVisibilityOfElementLocated(campoDescricao);
        click(campoDescricao);
        sendKeys(campoDescricao, cmpDesc);
    }

    public void clicarBotaoSalvar() {
        waitForVisibilityOfElementLocated(btnSalvar);
        click(btnSalvar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //ABA PRODUTOS:
    public void clicarNoSegundoAdicionar() {
        waitForVisibilityOfElementLocated(btnAdicionar2);
        click(btnAdicionar2);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void clicarNoIconeProduto() {
        waitForVisibilityOfElementLocated(btnIcon);
        click(btnIcon);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void digitarNomeDoProduto(String descProduto) {
        sendKeys(campoProcurarFloatControl, descProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void selecionarProduto() {
        waitForVisibilityOfElementLocated(produto);
        click(produto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void limparCampoAlmoxarifado() {
        waitForVisibilityOfElementLocated(btnXlimpar2);
        click(btnXlimpar2);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void clicarNoSegundoAlmoxarifado() {
        waitForVisibilityOfElementLocated(btnIconAlmoxarifado2);
        click(btnIconAlmoxarifado2);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void digitarNoCampoPesquisaAlmoxarifado(String descAlmoxarifado) {
        sendKeys(campoProcurarFloatControl, descAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void selecionarSegundoAlmoxarifado() {
        waitForVisibilityOfElementLocated(almoxarifado);
        click(almoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //lote:
    public void inserirLote(String DescCampoLote) {
        waitForVisibilityOfElementLocated(campoLote);
        click(campoLote);
        sendKeys(campoLote, DescCampoLote);
    }

    public void clicarBotaoCalendario() {
        waitForVisibilityOfElementLocated(btnCalendario2);
        click(btnCalendario2);
    }

    //Data de Validade - Calendario
    public void selecionarDataValidade() {
        waitForVisibilityOfElementLocated(DataEscolhidaAtual);
        click(DataEscolhidaAtual);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //btn confirmar:
    public void clicarBotaoConfirmar() {
        waitForVisibilityOfElementLocated(confirmar);
        click(confirmar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //caixa de texto:
    public void clicarParaConfirmarMensagem() {
        waitForVisibilityOfElementLocated(caixaTextoImplantacaoEstoque);
        waitForVisibilityOfElementLocated(btnSim);
        click(btnSim);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //aba-produtos -quantidade:
    public void abaProdutoInserirQuantidade(String quantidade) {
        waitForVisibilityOfElementLocated(campoQuantidade);
        clear(campoQuantidade);
        sendKeys(campoQuantidade, quantidade);
    }

    //aba-produtos -Vr.Liquido:
    public void campoValorLiquido(String quantidade) {
        waitForVisibilityOfElementLocated(campoVrLiquido);
        clear(campoVrLiquido);
        sendKeys(campoVrLiquido, quantidade);
    }

    //aba-produtos -Vr.Bruto:
    public void campoValorBruto(String quantidade) {
        waitForVisibilityOfElementLocated(campoVrBruto);
        clear(campoVrBruto);
        sendKeys(campoVrBruto, quantidade);
    }

    //Salvar
    public void selecionarBotaoSalvar() {
        waitForVisibilityOfElementLocated(btnSalvar3);
        click(btnSalvar3);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //AtualizarEstoque
    public void clicarEmAtualizar() {
        waitForVisibilityOfElementLocated(btnAtualizarEstoque);
        click(btnAtualizarEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //Gravar Estoque
    public void clicarEmGravarImplantacao() {
        waitForVisibilityOfElementLocated(caixaTextoImplantacaoEstoque);
        waitForVisibilityOfElementLocated(btnGravar);
        click(btnGravar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //Estoque Atualizado
    public void estoqueAtualizadoComSucesso() {
        waitForVisibilityOfElementLocated(caixaTextoEstoqueAtualizadoComSucesso);
        waitForVisibilityOfElementLocated(btnEstoqueAtualizadoComSucesso);
        click(btnEstoqueAtualizadoComSucesso);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //ROTINA DE ATUALIZAR A PAGINA NO FLOAT-CONTROL APOS O LANÇAMENTO
    public void atualizarPagina() {
        waitForVisibilityOfElementLocated(iconFloatLupa);
        click(iconFloatLupa);
        waitForVisibilityOfElementLocated(iconReflesh);
        click(iconReflesh);
    }


    public void EditarImplantacaoEstoque(String cmpDesc2, String quantidadeEdit,String descProduto2,String descAlmoxarifado,String DescCampoLote){

        //Inicio:
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(localizandoDescricao);
        click(localizandoDescricao);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnEditar);
        click(btnEditar);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(campoDescricao2);
        click(campoDescricao2);
        clear(campoDescricao2);
        sendKeys(campoDescricao2,cmpDesc2);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnSalvar);
        click(btnSalvar);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(abaProduto);
        click(abaProduto);
        waitForInvisibilityOfElementLocated(loadingWait);

        //ADICIONANDO O SEGUNDO PRODUTO
        waitForVisibilityOfElementLocated(btnAdicionar3);
        click(btnAdicionar3);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnIconSearch);
        click(btnIconSearch);

            //inicio busca no float-control
            waitForVisibilityOfElementLocated(campoProcurarFloatControl);
            click(campoProcurarFloatControl);
            sendKeys(campoProcurarFloatControl,descProduto2);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(produto2);
            click(produto2);
            //fim  busca no float-control

        //SUB FILTRO - INFORMAÇOES COMPLEMENTARES DO PRODUTO:
        waitForVisibilityOfElementLocated(btnXlimpar2);
        click(btnXlimpar2);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnIconAlmoxarifado2);
        click(btnIconAlmoxarifado2);
        waitForInvisibilityOfElementLocated(loadingWait);

            //inicio busca no float-control
            waitForVisibilityOfElementLocated(campoProcurarFloatControl);
            click(campoProcurarFloatControl);
            sendKeys(campoProcurarFloatControl,descAlmoxarifado);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(almoxarifado);
            click(almoxarifado);
            waitForInvisibilityOfElementLocated(loadingWait);
            //fim  busca no float-control

        //lote:
            waitForVisibilityOfElementLocated(campoLote);
            click(campoLote);
            sendKeys(campoLote,DescCampoLote);

        //Data de Validade:

            waitForVisibilityOfElementLocated(btnCalendario2);
            click(btnCalendario2);
            waitForVisibilityOfElementLocated(DataEscolhidaAtual);
            click(DataEscolhidaAtual);
            waitForInvisibilityOfElementLocated(loadingWait);
        //btn confirmar:
            waitForVisibilityOfElementLocated(confirmar);
            click(confirmar);
            waitForInvisibilityOfElementLocated(loadingWait);
        //caixa de texto:
            waitForVisibilityOfElementLocated(caixaTextoImplantacaoEstoque);
            waitForVisibilityOfElementLocated(btnSim);
            click(btnSim);
            waitForInvisibilityOfElementLocated(loadingWait);
        //aba-produtos -quantidade:
            waitForVisibilityOfElementLocated(campoQuantidade);
            clear(campoQuantidade);
            sendKeys(campoQuantidade,quantidadeEdit);
        //aba-produtos -Vr.Liquido:
            waitForVisibilityOfElementLocated(campoVrLiquido);
            clear(campoVrLiquido);
            sendKeys(campoVrLiquido,quantidadeEdit);
        //aba-produtos -Vr.Bruto:
            waitForVisibilityOfElementLocated(campoVrBruto);
           clear(campoVrBruto);
            sendKeys(campoVrBruto,quantidadeEdit);

        //Salvar/Atualizar Estoque:
            waitForVisibilityOfElementLocated(btnSalvar3);
            click(btnSalvar3);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(btnAtualizarEstoque);
            click(btnAtualizarEstoque);
            waitForInvisibilityOfElementLocated(loadingWait);

        //Gravar/Estoque atualizado com sucesso:
            waitForVisibilityOfElementLocated(caixaTextoImplantacaoEstoque);
            waitForVisibilityOfElementLocated(btnGravar);
            click(btnGravar);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(caixaTextoEstoqueAtualizadoComSucesso);
            waitForVisibilityOfElementLocated(btnEstoqueAtualizadoComSucesso);
            click(btnEstoqueAtualizadoComSucesso);
            waitForInvisibilityOfElementLocated(loadingWait);

        //inicio - ROTINA DE ATUALIZAR A PAGINA NO FLOAT-CONTROL APOS O LANÇAMENTO
            waitForVisibilityOfElementLocated(iconFloatLupa);
            click(iconFloatLupa);
            waitForVisibilityOfElementLocated(iconReflesh);
            click(iconReflesh);
        //fim - ROTINA DE ATUALIZAR A PAGINA NO FLOAT-CONTROL APOS O LANÇAMENTO


    }
    public void ExcluirImplantacaoEstoque(){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(localizandoDescricaoExcluir);
        click(localizandoDescricaoExcluir);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnExcluir);
        click(btnExcluir);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(AlertExcluirRegistro);
        waitForVisibilityOfElementLocated(btnSim);
        click(btnSim);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(AlertExcluirRegistro);
        waitForVisibilityOfElementLocated(btnOkAlert);
        click(btnOkAlert);

    }

    public void ImportarImplantacaoDeEstoque(){
        //INICIO:
        waitForVisibilityOfElementLocated(btnImportar);
        click(btnImportar);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnEscolherArquivo);
        click(btnEscolherArquivo);

    }

}
